=== cilium/ebpf@v0.0.0-20200702112145-1c8d4c9ef775/internal/btf/testdata/Makefile ===
# Usage: make KDIR=/path/to/foo

vmlinux-btf.gz: $(KDIR)/vmlinux
	objcopy --dump-section .BTF=/dev/stdout "$<" | gzip > "$@"
